import { Box3, Material, Object3D, WebGLRenderer } from 'three';
import SpeckleMesh, { TransformStorage } from '../objects/SpeckleMesh';
import { NodeRenderView } from '../tree/NodeRenderView';
import { Batch, BatchUpdateRange, GeometryType } from './Batch';
import { DrawGroup } from './InstancedMeshBatch';
export default class MeshBatch implements Batch {
    id: string;
    subtreeId: string;
    renderViews: NodeRenderView[];
    private transformStorage;
    private geometry;
    batchMaterial: Material;
    mesh: SpeckleMesh;
    private gradientIndexBuffer;
    private indexBuffer0;
    private indexBuffer1;
    private indexBufferIndex;
    private needsShuffle;
    private needsFlatten;
    get bounds(): Box3;
    get drawCalls(): number;
    get minDrawCalls(): number;
    get triCount(): number;
    get vertCount(): number;
    constructor(id: string, subtreeId: string, renderViews: NodeRenderView[], transformStorage: TransformStorage);
    get geometryType(): GeometryType;
    get renderObject(): Object3D;
    getCount(): number;
    get materials(): Material[];
    get groups(): DrawGroup[];
    setBatchMaterial(material: Material): void;
    onUpdate(deltaTime: number): void;
    onRender(renderer: WebGLRenderer): void;
    setVisibleRange(...ranges: BatchUpdateRange[]): void;
    getVisibleRange(): BatchUpdateRange;
    getOpaque(): BatchUpdateRange;
    getTransparent(): BatchUpdateRange;
    getStencil(): BatchUpdateRange;
    setBatchBuffers(...range: BatchUpdateRange[]): void;
    setDrawRanges(...ranges: BatchUpdateRange[]): void;
    private getDrawRangeCollision;
    private geDrawRangeInclusion;
    private sortGroups;
    private flattenDrawGroups;
    private getCurrentIndexBuffer;
    private getNextIndexBuffer;
    private shuffleDrawGroups;
    resetDrawRanges(): void;
    static bufferSetup: number;
    static arrayWork: number;
    static objectBvh: number;
    static computeNormals: number;
    static computeBoxAndSphere: number;
    static computeRTE: number;
    static batchBVH: number;
    buildBatch(): void;
    getRenderView(index: number): NodeRenderView;
    getMaterialAtIndex(index: number): Material;
    getMaterial(rv: NodeRenderView): Material;
    private makeMeshGeometry;
    private updateGradientIndexBufferData;
    private updateGradientIndexBuffer;
    purge(): void;
}
